<template>
  <Container class="h-full">
    <section class="flex items-center justify-between gap-2">
      <SectionHeader icon="mdi-calendar-clock-outline">
        Даты
      </SectionHeader>

      <EditDates
        :booking="booking"
        @update="($endDate: string) => emit('update:dates', $endDate)"
      />
    </section>

    <PluginCalendar
      :locale="{ id: 'ru', masks: { weekdays: 'WW' } }"
      class="w-full rounded-none shadow-none border-0"
      :min-date="startDate.startOf('month').toJSDate()"
      :max-date="endDate.endOf('month').toJSDate()"
      :attributes="[{
        key: booking.id,
        dates: { start: startDate.toJSDate(), end: endDate.toJSDate() },
        highlight: {
          start: {
            contentStyle: { color: booking.property.color },
            style: { borderColor: booking.property.color },
            fillMode: 'outline',
          },
          base: {
            contentStyle: { color: 'white', textShadow: '0 0 3px #555' },
            style: { backgroundColor: booking.property.color, opacity: 0.6 },
            fillMode: 'light',
          },
          end: {
            contentStyle: { color: booking.property.color },
            style: { borderColor: booking.property.color },
            fillMode: 'outline',
          },
        },
      }]"
    />
  </Container>
</template>

<script setup lang="ts">
import { computed } from 'vue';

import { useDateTime } from '@/composables';

import Container from '@/components/layout/Container.vue';
import SectionHeader from '@/components/layout/SectionHeader.vue';
import EditDates from './EditDates.vue';

const props = defineProps<{ booking: IVerboseBooking }>();
const emit = defineEmits(['update:dates']);

const dt = useDateTime();

const startDate = computed(() => {
  return dt.wrap(props.booking.startDate);
});

const endDate = computed(() => {
  return dt.wrap(props.booking.endDate);
});
</script>